# Creating a car set literal
# A set in python programming is a collection which is unordered and un-indexed
cars = {'BMW', 'Honda', 'Audi', 'Mercedes', 'Honda', 'Toyota', 'Ferrari', 'Tesla'}

# 2. Accessing the values from the set
# Approach1 -
print('Approach #1= ', cars)

print('==========')

# Approach2 -
print('Approach #2')
for car in cars:
    print('Car name = {}'.format(car))

print('==========')

# 3. Adding an element to the set and accessing it
# There is no specific index attached
cars.add('Tata')
print('New cars set = {}'.format(cars))

print('==========')

# 4. Removing an element from the set
# There is no specific index attached
cars.discard('Mercedes')
print('discard() method = {}'.format(cars))

print('==========')

# 5. Basic functions over set
oddDays = {"Mon", "Wed", "Fri"}
allDays = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"}

# 5(a). Union of sets
# Union operation produces a new set containing all the distinct elements from both the sets
union = oddDays | allDays
print("Union of sets = {}".format(union))

print('==========')

# 5(b). Intersection of sets
# Intersection operation produces a new set containing only common elements from both the sets
intersection = oddDays & allDays
print("Intersection of sets = {}".format(intersection))

print('==========')

# 5(c). Difference of sets
# Difference operation produces a new set containing only the elements from the first set and none from the second set
difference = allDays - oddDays
print("Difference of sets = {}".format(difference))

print('==========')

# 5(c). Compare sets
# Compare operation checks if a given set is a subset or superset of the another set
# The result is true or false depending on the elements present in the sets
subset = oddDays <= allDays
superset = allDays >= oddDays
print("Subset result = {}".format(subset))
print("Superset result = {}".format(superset))
